using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;

namespace IDP
{
    interface IGraphic
    {
        bool I3DGenerateGraphic(long lWidth, long lHeight);

    }// End of I3DSurfaceGen

    interface IRender
    {
        bool IRenderToFile(string sFileName);
        
        bool IRenderToScreen(System.Drawing.Graphics oGraphics
                          , System.Drawing.Pen oPen);

        bool IRenderToScreenDelayed(System.Drawing.Graphics oGraphics
                          , System.Drawing.Pen oPen);
        
        bool IRenderToBitmap(Bitmap oBmp);

        bool IRenderToBitmapDelayed(Bitmap oBmp);

    }// End of IRender

    interface I3DSurface : IRender
    {

        bool I3DGenerate3DSurface(long l3DSurfaceType
                                    , long lWidth
                                    , long lHeight);

    }// End of I3DSurface

    interface IDigitalFlower : IGraphic, IRender
    {
        bool IGenerateDigitalFlower(long lWidth
                                    , long lHeight
                                    , double dblPrecision);
        //Todo: Add code here 

    }// End of IDigitalFlower
}
