using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace IDP
{
    public partial class frmMain : Form
    {
        private _3DSurface m_o3DSurface;
        private _3DSurface m_o3DSurfaceExt1;
        private _3DSurface m_o3DSurfaceExt2;
        private DigitalFlower m_oDigitalFlower;
        private long m_lIndex = 0;
        private Bitmap m_oBmpDFlower;
        private Graphics m_oBmpGrDFlower;
        private Bitmap m_oBmp3D;
        private Graphics m_oBmpGr3D;
        private Bitmap m_oBmp3DExt1;
        private Graphics m_oBmpGr3DExt1;
        private Bitmap m_oBmp3DExt2;
        private Graphics m_oBmpGr3DExt2;
        private string sPath = System.IO.Path.GetDirectoryName(
            System.Reflection.Assembly.GetExecutingAssembly().CodeBase);

        public frmMain()
        {
            InitializeComponent();
        }

        private void frmMain_Load(object sender, EventArgs e)
        {
            //this.timer1.Stop();

            m_oBmpDFlower = new Bitmap(picDigitalFlower.Width
                                        , picDigitalFlower.Height
                                        , System.Drawing.Imaging.PixelFormat.Format24bppRgb);
            m_oBmpGrDFlower = Graphics.FromImage(m_oBmpDFlower);

            m_oBmp3D = new Bitmap(pic3DSurface.Width
                                    , pic3DSurface.Height
                                    , System.Drawing.Imaging.PixelFormat.Format24bppRgb);
            m_oBmpGr3D = Graphics.FromImage(m_oBmp3D);

            m_oBmp3DExt1 = new Bitmap(pic3DSurfaceExt1.Width
                                        , pic3DSurfaceExt1.Height
                                        , System.Drawing.Imaging.PixelFormat.Format24bppRgb);
            m_oBmpGr3DExt1 = Graphics.FromImage(m_oBmp3DExt1);

            m_oBmp3DExt2 = new Bitmap(pic3DSurfaceExt2.Width
                                        , pic3DSurfaceExt2.Height
                                        , System.Drawing.Imaging.PixelFormat.Format24bppRgb);
            m_oBmpGr3DExt2 = Graphics.FromImage(m_oBmp3DExt2);

        }

        private void btnDraw3D_Click(object sender, EventArgs e)
        {
            m_lIndex = 0;
            m_o3DSurface = new _3DSurface();
            m_oDigitalFlower = new DigitalFlower();
            m_o3DSurfaceExt1 = new _3DSurface();
            m_o3DSurfaceExt2 = new _3DSurface();
            
            m_oDigitalFlower.DFGenerate(this.picDigitalFlower.Width
                                        , this.picDigitalFlower.Height 
                                        , 0.001);

            m_o3DSurface.I3DGenerate3DSurface(m_o3DSurface._3DSurfceTypeCos
                                                , this.pic3DSurface.Width
                                                , this.pic3DSurface.Height);

            m_o3DSurfaceExt1.I3DGenerate3DSurface(m_o3DSurfaceExt1._3DSurfceTypeExt
                                                , this.pic3DSurfaceExt1.Width
                                                , this.pic3DSurfaceExt1.Height);

            m_o3DSurfaceExt2.I3DGenerate3DSurface(m_o3DSurfaceExt2._3DSurfaceTypesin
                                                , this.pic3DSurfaceExt2.Width
                                                , this.pic3DSurfaceExt2.Height);

            m_o3DSurface.IRenderToBitmap(m_oBmp3D);
            m_o3DSurfaceExt1.IRenderToBitmap(m_oBmp3DExt1);
            m_o3DSurfaceExt2.IRenderToBitmap(m_oBmp3DExt2);
            m_oDigitalFlower.IRenderToBitmap(m_oBmpDFlower);

            this.picDigitalFlower.Image = m_oBmpDFlower;
            this.pic3DSurface.Image = m_oBmp3D;
            this.pic3DSurfaceExt1.Image = m_oBmp3DExt1;
            this.pic3DSurfaceExt2.Image = m_oBmp3DExt2;

            //this.timer1.Start();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            System.Drawing.Graphics oGDF;
            oGDF = this.picDigitalFlower.CreateGraphics();
            System.Drawing.Pen oPenDF;
            oPenDF = new Pen(System.Drawing.Color.White, 0.0f);

            System.Drawing.Graphics oGraph3D;
            oGraph3D = this.pic3DSurface.CreateGraphics();
            System.Drawing.Pen oPen3D;
            oPen3D = new Pen(System.Drawing.Color.White, 0.0f);

            m_oDigitalFlower.IRenderToBitmapDelayed(m_oBmpDFlower);
            m_o3DSurface.IRenderToBitmapDelayed(m_oBmp3D);

            picDigitalFlower.Image = m_oBmpDFlower;
            pic3DSurface.Image = m_oBmp3D;
            m_lIndex++;

            //if ((m_lIndex > m_oDigitalFlower.DFPointArrLim) || (m_lIndex > m_o3DSurface._3DSurfacePointLim))
            //{
            //    this.timer1.Stop();
            //    m_oBmp3D.Save("c:\\3dSurface.bmp");
            //    m_oBmpDFlower.Save("c:\\DigitalFlower.jpg");
            //}
            //m_oBmp3D.Save("c:\\3dSurface.bmp");
            //m_oBmpDFlower.Save("c:\\DigitalFlower.jpg");

        }
    }
}